diff --git a/src/backend/replication/slot.c b/src/backend/replication/slot.c
index 2180a38063..890dd33892 100644
--- a/src/backend/replication/slot.c
+++ b/src/backend/replication/slot.c
@@ -1757,10 +1757,8 @@ CheckPointReplicationSlots(bool is_shutdown)
 		{
 			SpinLockAcquire(&s->mutex);
 
-			Assert(s->data.confirmed_flush >= s->last_saved_confirmed_flush);
-
 			if (s->data.invalidated == RS_INVAL_NONE &&
-				s->data.confirmed_flush != s->last_saved_confirmed_flush)
+				s->data.confirmed_flush > s->last_saved_confirmed_flush)
 			{
 				s->just_dirtied = true;
 				s->dirty = true;
